local mc		= require 'newmaincode'
local thread	= love.thread.newThread( 'thread.lua' )

function love.load()
	--love._openConsole()
	imageData		= love.image.newImageData( 'pic.jpg' )
    image			= love.graphics.newImage( imageData )
	love.window.setMode( image:getWidth(),image:getHeight() )
	love.window.setTitle( 'Test of Thread' )
	start			= 0
	num				= 0
	-- functions to use for processing imagedata (sent to thread)
	funk = {[[function process( x, y, r, g, b, a )
    a = 255
    r = r-255*math.sqrt((x-400)^2+(y-300)^2)/350
    g = g-255*math.sqrt((x-400)^2+(y-300)^2)/350
    b = b-255*math.sqrt((x-400)^2+(y-300)^2)/350
    return r, g, b, a
	end]],
	[[function process( x, y, r, g, b, a )
    a = 255
    r = g-19
    b,g = g-10,b-9
    return r, g, b, a
	end]]}
	DataProcessed 	= processImageData( imageData )
	end

function love.draw()
    love.graphics.setColor( 255, 255, 255, 255 )
    love.graphics.draw( image )
	love.graphics.print( 'delay update: '..math.floor(10*start)/10, 10, 10 )
	end

function love.update( dt )
	start = start + dt
	if start >= 1 then		-- just reprocess after a delay
		start				= 0
		print('****************************')
		DataProcessed		= processImageData( imageData )
		end
	if DataProcessed then
		local dataReceived	= mc.main.requestData()
		if dataReceived then
			imageData		= dataReceived
			image			= love.graphics.newImage( imageData )
			collectgarbage( 'collect' )
			DataProcessed	= false
			end
		end
	end

function love.keypressed(key)
    if  key == "q" or key == "escape" then
        love.event.push('quit')
		end
	end

function love.threaderror( thread, err )
    error( err )
	end

function processImageData( im )
	thread:start()
	num = num + 1
	msg = 'main: Hi Thread! Will be sending you data set number '..num
	mc.main.send( msg )
	mc.main.send( funk[2] )
	mc.main.send( im )
	return true		-- process started but result not received
	end
