local threadcode	= {}

threadcode.main = {}
threadcode.main.SendChannel	= love.thread.getChannel( 'toThread' )
threadcode.main.ReceiveChannel	= love.thread.getChannel( 'fromThread' )

function threadcode.main.send( dat )
	print( 'main: sending '..type( dat ) )
	threadcode.main.SendChannel:push( dat )
	print( 'main: '..type( dat )..' sent' )
	threadcode.main.receiveConfirmation()	-- main blocked
	end

function threadcode.main.requestData()		-- non-blocking, checking availability
	print( 'main: waiting for reply' )
	local data = threadcode.main.ReceiveChannel:pop()
	if data then
		print( 'main: '..type(data)..' received' )
		threadcode.main.send( true )		-- confirm reception
		end
	return data
	end

function threadcode.main.receiveConfirmation()	-- blocking until transfer confirmed
	print( 'main: waiting confirmation' )
	dat	= nil
	while not dat do dat = threadcode.main.ReceiveChannel:demand() end
	print('main: Glad to hear thread received '..type( dat ))
	return dat
	end

return threadcode
